unit Reminder;

interface

procedure _Main;

implementation

uses SysUtils,WerCrt,DateUtils;
type
event=record
      name:string[60];
      day,month,weekday:word;
      daysleft:longint;
      end;

var
events:array[1..500]of event;
eventsnr:byte;

curyear,curmonth,curday,curweekday:word;

const
monthnames:array[1..12]of string[15]=(
'January',      {31   * }
'February',     {28 *   }
'March',        {31   * }
'April',       {30  *  }
'May',           {31   * }
'June',         {30  *  }
'July',         {31   * }
'August',        {31   * }
'September',    {30  *  }
'Octomber',     {31   * }
'November',     {30  *  }
'December');    {31   * }
weekdaynames:array[1..7]of string[15]=(
'Sunday',
'Monday',
'Tuesday',
'Wednesday',
'Thursday',
'Friday',
'Saturday');

function ok(ev:event):boolean;
begin
ok:=false;
with ev do
  begin
  if(month=0)or(day=0)or(month>12)then exit;
  case month of
    1,3,5,7,8,10,12:if day>31 then exit;
    4,6,9,11:if day>30 then exit;
    2:if day>29 then exit
    end;
  end;
ok:=true;
end;

function dbd(day,month:word;var weekday:word):longint;
var count:longint;test:event;i:byte;
begin
count:=-2;
{getdate(curyear,curmonth,curday,curweekday);}
DecodeDateFully(Today,CurYear,CurMonth,CurDay,CurWeekDay);
for i:=1 to 2 do
  begin
  dec(curday);
  if curday=0 then
    begin
    dec(curmonth);
    if curmonth=0 then
      begin
      dec(curyear);
      curmonth:=12;
      end;
    case curmonth of
      1,3,5,7,8,10,12:
        curday:=31;
      4,6,9,11:
        curday:=30;
      2:if curyear mod 4=0 then
          curday:=29
        else
          curday:=28
      end;
    end;
  end;
//curweekday:=(curweekday+5)mod 7;

while not((curmonth=month)and(curday=day))do
  begin

  test.day:=curday;test.month:=curmonth;
  if not ok(test)then begin writeln('Internal error at record nr. '+IntToStr(eventsnr));halt end;
  if curyear>2100 then begin writeln('Invalid data in record nr. '+IntToStr(eventsnr));halt end;

  inc(curday); inc(count);

  case curmonth of
    1,3,5,7,8,10,12:
      if curday>31 then
        begin
        curday:=1;
        inc(curmonth);
        end;
    4,6,9,11:
      if curday>30 then
        begin
        curday:=1;
        inc(curmonth);
        end;
    2:if curyear mod 4=0 then
        begin
        if curday>29 then
          begin
          curday:=1;
          inc(curmonth);
          end
        end
      else
        if curday>28 then
          begin
          curday:=1;
          inc(curmonth);
          end
    end;
  if curmonth>12 then
    begin
    curmonth:=1;
    inc(curyear);
    end;
  inc(curweekday);
  if curweekday>6 then curweekday:=0;
  end;
//weekday:=curweekday;
DecodeDateFully(EncodeDate(CurYear,CurMonth,CurDay),CurYear,CurMonth,CurDay,WeekDay);
dbd:=count;
end;

function path:string;
var s:string;i:byte;
begin
s:=paramstr(0);
for i:=length(s) downto 1 do
  if s[i]='\'then
    begin
    path:=copy(s,1,i);
    exit
    end;
getdir(0,s);
if s[length(s)]<>'\' then
  s:=s+'\';
path:=s;
end;

procedure readdata;
var
f:text;
begin
assign(f,path+'data.txt');
reset(f);
while not eof(f)do
  begin
  inc(eventsnr);
  with events[eventsnr]do
    begin
    readln(f,day,month,name);
    if not ok(events[eventsnr])then begin writeln('Invalid data in record nr. '+IntToStr(eventsnr));halt end;

    daysleft:=dbd(day,month,weekday);
    end;
  end;
close(f);
end;

procedure sortdata;
var i:byte;
t:event;
begin
i:=1;
while i<eventsnr do
  if events[i].daysleft<=events[i+1].daysleft then
    inc(i)
  else
    begin
    t:=events[i];
    events[i]:=events[i+1];
    events[i+1]:=t;
    if i>1 then
      dec(i);
    end;
end;

procedure _Main;
var {wd,}i:word;
begin
//getdate(curyear,curmonth,curday,curweekday);
DecodeDateFully(Today,CurYear,CurMonth,CurDay,CurWeekDay);
textcolor(white);
writeln;
writeln('Today is '+IntToStr(curday)+' '+monthnames[curmonth]+', '+weekdaynames[curweekday]+'.');
readdata;
sortdata;
for i:=1 to eventsnr do
  with events[i]do
    begin
    case daysleft of
         -2:textattr:=red;
         -1:textattr:=lightred;
          0:textattr:=yellow;
      1.. 2:textattr:=lightgreen;
      3.. 6:textattr:=green;
      7..31:textattr:=blue;
      end;
    if daysleft<32 then
      if name[1]<>'#' then
        begin
        case daysleft of
         -1:write('                         Yesterday ');
          0:write('                             Today ');
          1:write('                          Tomorrow ');
          else
            write('                              ('+St(daysleft,2,' ')+') ');
          end;
        writeln(name+#13+St(day,2,' ')+' '+monthnames[month]+', '+weekdaynames[weekday]);
        end;
    end;
textcolor(lightgray);
writeln;
end;

end.
